######## Notes
## Redo background sound measurement for 008 #Fixed
## Redo background sound measurement for 045 #Fixed
## Redo background sound measurement for 055 #Fixed
## Redo Acoustic property files for 028 #Fixed

##Home Drive
##Drive <- "G:/"
##Work Drive
#Drive <- "E:/"
##Random Drive
#Drive <- "F:/"
#Home
Drive <- "H:/"


whisleListSize <- 78
fullpath <- ""
filtpath <- ""

##Get colours from banding Database
ColourDB <-data.frame()
ColourDB <- read.csv( paste0(Drive, "Removal_List.csv"))
RemovalColours <- c()
for( i in 1:length(ColourDB[[1]])){
##	if(){
		if(is.na(ColourDB[i,4])){
			RemovalColours <- c(RemovalColours, 'black')
		}
		else if(ColourDB[i,2]  == 'Trim P9'){
			RemovalColours <- c(RemovalColours, 'blue')
		}
		else if(ColourDB[i,2] == 'Trim P8'){
			RemovalColours <- c(RemovalColours, 'red')
		}
		else if(ColourDB[i,2] == 'Trim P7'){
			RemovalColours <- c(RemovalColours, 'green')
		}
		else if(ColourDB[i,2] == 'Control'){
			RemovalColours <- c(RemovalColours, 'yellow')
		}
		else {
			RemovalColours <- c(RemovalColours, 'black')
		}
##	}
}

RemovalAnalysisDF <- data.frame()
RemovalFilteredDF <- data.frame()
AmplitudeMeans <- data.frame()
EntropyMeans <- data.frame()
column_names <- c("ToneID", "Amplitude", "Entropy", "Tone.Type", "WhistleID", "Colour", "Background")
Mean_ColumnNames <- c("Amplitude", "Entropy", "Tone.Type","Colour", "WhistleID", "Background")
meanAmplitude <- data.frame()
meanEntropy <- data.frame()
RemovalMeans <- data.frame()

TreatmentColours <- c()
for( i in 1:whisleListSize ){
	filename <- as.character(i)
	filtname <- as.character(i)

	if(nchar(filename) == 1){
		filename <- paste0("00", filename, ".txt")
		filtname <- paste0("00", filtname , "_Filt.txt")
	}else if(nchar(filename) == 2){
		filename <- paste0("0", filename, ".txt")
		filtname <- paste0("0", filtname , "_Filt.txt")
	}
	print(filename)
	tempDF <- data.frame()
	fullpath <- paste0( Drive, "Banding and Feather Removal/AnalysisWorkspaces/", filename)
	if( file.exists(fullpath ) ){
		tempDF <- read.table( fullpath, sep="\t", header=TRUE)
		tempDF <- tempDF[c(F,T), c(1,6, 7, 10, 11)]	
		tempDF <- cbind(tempDF, rep(RemovalColours[i], nrow(tempDF)) )		
		tempDF <- cbind(tempDF, rep(ColourDB[i,4], nrow(tempDF)) )
		names(tempDF) <- column_names 
		EntropyA <- cbind(NA, as.numeric(mean(tempDF[tempDF$Tone.Type== "A",]$Entropy)), "A", RemovalColours[i], ColourDB[i,1], as.numeric(ColourDB[i,4]))
		EntropyB <- cbind(NA, as.numeric(mean(tempDF[tempDF$Tone.Type== "B",]$Entropy)), "B", RemovalColours[i], ColourDB[i,1], as.numeric(ColourDB[i,4]))		
	}else{
		print("file not found")
	}
	filtpath <- paste0( Drive, "Banding and Feather Removal/AnalysisWorkspaces/", filtname)
	if( file.exists(filtpath ) ){
		tempFilt <- read.table( filtpath , sep="\t", header=TRUE)
		tempFilt <- tempFilt[c(F, T),c(1,6, 7, 10, 11)]
		tempFilt <- cbind(tempFilt , rep(RemovalColours[i], nrow(tempDF)))
		TreatmentColours <- c(TreatmentColours, RemovalColours[i])
		tempFilt <- cbind(tempFilt , rep(ColourDB[i,4], nrow(tempDF)))
		names(tempFilt ) <- column_names
		EntropyA[,1] <- as.numeric(mean(tempFilt[tempFilt$Tone.Type == "A",]$Amplitude))
		if(i == 54){
			print(EntropyA)
		}
		EntropyB[,1] <- as.numeric(mean(tempFilt[tempFilt$Tone.Type== "B",]$Amplitude))
##		meanAmplitude <- rbind(AmplitudeA , AmplitudeB )
##		names(meanAmplitude) <- Mean_ColumnNames	
		
		RemovalMeans <- rbind(RemovalMeans, EntropyA, EntropyB)
	}else{
		print("file not found")
		EntropyA <- NA
		EntropyB <- NA
	}
	RemovalAnalysisDF <- rbind(RemovalAnalysisDF, tempDF)
	RemovalFilteredDF <- rbind(RemovalFilteredDF, tempFilt)
	
}
names(RemovalMeans ) <- Mean_ColumnNames
RemovalMeans$Entropy <- as.numeric(as.character(RemovalMeans$Entropy))
RemovalMeans$Amplitude <- as.numeric(as.character(RemovalMeans$Amplitude))
RemovalMeans$Background <- as.numeric(as.character(RemovalMeans$Background ))
RemovalAnalysisDF$Entropy <- as.numeric(as.character(RemovalAnalysisDF$Entropy))
RemovalAnalysisDF$Background <- as.numeric(as.character(RemovalAnalysisDF$Background ))
RemovalAnalysisDF$WhistleID <- as.factor(RemovalAnalysisDF$WhistleID)
RemovalFilteredDF $Amplitude <- as.numeric(as.character(RemovalFilteredDF $Amplitude ))
RemovalFilteredDF $Background <- as.numeric(as.character(RemovalFilteredDF $Background ))
RemovalFilteredDF $WhistleID <- as.factor(RemovalFilteredDF $WhistleID)

TempA <- RemovalMeans$Tone.Type == 'A'
TempB <- RemovalMeans$Tone.Type == 'B'
tempAmpA <- RemovalMeans$Amplitude[TempA] - RemovalMeans$Background[TempA]
tempAmpB <- RemovalMeans$Amplitude[TempB] - RemovalMeans$Background[TempB]
ampRatioA <- tempAmpA  - tempAmpB
ampRatioB <- tempAmpB  - tempAmpA
ampSub <- c(numeric(nrow(RemovalMeans)))
ampSub [TempA] <- ampRatioA 
ampSub [TempB] <- ampRatioB
RemovalMeans <- cbind(RemovalMeans, ampSub )

boxplot(Entropy ~ Tone.Type + Colour, data = RemovalAnalysisDF, main = "Tone B Entropy", col = RemovalColours, na.rm=TRUE)
boxplot(Amplitude ~ Tone.Type, data = RemovalAnalysisDF, main = "Tone A Amplitude", col = RemovalColours, na.rm=TRUE)

boxplot(RemovalAnalysisDF$Avg.Entropy..u.   ~ RemovalAnalysisDF$ID, data = RemovalAnalysisDF[RemovalAnalysisDF$Tone.Type == 'A'], main = "Tone A Entropy", col = RemovalColours, na.rm=TRUE)
##subtract background amplitude from whistle amp

boxplot(Entropy ~ WhistleID, data = RemovalAnalysisDF[RemovalAnalysisDF$Tone == "A",], main = "Tone A Entropy", col = TreatmentColours )
boxplot(Entropy ~ WhistleID, data = RemovalAnalysisDF[RemovalAnalysisDF$Tone == "B",], main = "Tone B Entropy", col = TreatmentColours )

boxplot(Amplitude - BackgroundAmplitude ~ Colour, data = ToneAList, main = "Tone A Amplitude", col = TreatmentColours, na.rm=TRUE)
boxplot(Amplitude - BackgroundAmplitude ~ Colour, data = ToneBList, main = "Tone B Amplitude", col = TreatmentColours, na.rm=TRUE)
boxplot(Amplitude ~ WhistleID, data = RemovalAnalysisDF[RemovalAnalysisDF$Tone == "B",], main = "Tone B Amplitude", col = RemovalColours, na.rm=TRUE)
ToneAAmp <- RemovalAnalysisDF[RemovalAnalysisDF$Tone == "A",]$Amplitude
ToneBAmp <- RemovalAnalysisDF[RemovalAnalysisDF$Tone == "B",]$Amplitude
boxplot(Amplitude - BackgroundAmplitude ~ Colour * Tone, data = RemovalFilteredDF , main = "Amplitude", col = c("yellow", "red", "blue", "green"), na.rm = TRUE)
boxplot(Entropy ~ Colour * Tone, data = RemovalFilteredDF , main = "Entropy", col = c("yellow", "red", "blue", "green"), na.rm = TRUE )

##Plot Means
par(mfrow = c(2,2))
boxplot(Entropy ~ Colour * Tone.Type, data = RemovalMeans, main = "Entropy", col = c("yellow", "red", "blue", "green") , na.rm = TRUE  )
boxplot(Amplitude -  Background ~ Colour * Tone.Type, data = RemovalMeans, main = "Amplitude", col = c("yellow", "red", "blue", "green") , na.rm = TRUE, ylim = c(0,35) )
boxplot(ampRatio ~ Colour * Tone.Type, data = RemovalMeans, main = "Amplitude", col = c("yellow", "red", "blue", "green") , na.rm = TRUE, ylim = c(0,7) )

mp <- barplot(predicted.means, stat="identity", beside = T, ylim = c(0,1) )

TempDataA <- RemovalMeans[RemovalMeans$Tone == "A",]
TempDataB <- RemovalMeans[RemovalMeans$Tone == "B",]
TempDataC <- TempDataA - TempDataB 
modifiedDatabase$ElementType + (1|modifiedDatabase$ID)

library(lme4)
###Entropy Just Means###
fit.lmer<- lmer( 10- Entropy ~  Colour * Tone.Type +(1|WhistleID), data=RemovalMeans)
summary(fit.lmer)
data = RemovalMeans[RemovalMeans$Tone.Type == 'A',]
fit.lmer<- lm( 10 - Entropy ~  Colour , data = data)
summary(fit.lmer)
TukeyHSD(fit.lmer)
data = RemovalMeans[RemovalMeans$Tone.Type == 'B',]
fit.lmer<- lm( 10 - Entropy ~  Colour , data = data)
summary(fit.lmer)
TukeyHSD(fit.lmer)

boxplot(Amplitude~ Tone.Type *WhistleID, data = RemovalAnalysisDF[RemovalAnalysisDF$Colour == 'green',])

###Entropy All data### All data is no good because can't get P values
data <- RemovalAnalysisDF[RemovalAnalysisDF$Tone.Type == 'A',]
#data <- data [data$Colour != 'green',]
fit.lmer <- lmer( 10- Entropy ~  Colour +(1|WhistleID), data=data)
summary(fit.lmer)
data <- RemovalAnalysisDF[RemovalAnalysisDF$Tone.Type == 'B',]
#data <- data [data$Colour != 'green',]
fit.lmer<- lmer( 10 - Entropy ~  Colour +(1|WhistleID), data=data)
summary(fit.lmer)

fit.lmer <- glmer( 10-Entropy ~  Colour * Tone.Type + (1|WhistleID), data=RemovalAnalysisDF)
summary(fit.lmer)
data <- RemovalAnalysisDF[RemovalAnalysisDF$Tone.Type == 'A',]
fit.lmer <- lm( 10 - Entropy ~  Colour, data=data)
summary(fit.lmer)
data <- RemovalAnalysisDF[RemovalAnalysisDF$Tone.Type == 'B',]
fit.lmer <- lm( 10- Entropy ~  Colour, data=data)
summary(fit.lmer)

data <- RemovalMeans[RemovalMeans$Tone.Type == 'A',]
fit.lmer <- lm( 10 - Entropy ~  Colour, data=data)
summary(fit.lmer)
data <- RemovalMeans[RemovalMeans$Tone.Type == 'B',]
fit.lmer <- lm( 10- Entropy ~  Colour, data=data)
summary(fit.lmer)


###Amplitude means###
fit.lmer<- lmer( Amplitude ~  Colour + Tone.Type + (1|WhistleID), data=RemovalMeans)
summary(fit.lmer)
fit.lmer<- lm( Amplitude ~  Colour * Tone.Type +(1|WhistleID), data=RemovalMeans)
summary(fit.lmer)

fit.lmer<- lmer( Amplitude ~  Colour + Tone.Type + (1|WhistleID), data=RemovalMeans)
summary(fit.lmer)
fit.lmer<- lm( Amplitude - Background~  Colour * Tone.Type, data=RemovalMeans)
summary(fit.lmer)

###Amplitude all data###
data <- RemovalFilteredDF[RemovalFilteredDF$Tone.Type == 'A',]
fit.lmer<- lmer( Amplitude - Background ~  Colour +(1|WhistleID), data=data)
summary(fit.lmer)
data <- RemovalFilteredDF[RemovalFilteredDF$Tone.Type == 'B',]
fit.lmer<- lmer( Amplitude - Background ~ Colour +(1|WhistleID), data=data)
summary(fit.lmer)

data <- RemovalMeans[RemovalMeans$Tone.Type == 'A',]
fit.lmer<- lm( Amplitude - Background ~  Colour , data=data)
summary(fit.lmer)
data <- RemovalMeans[RemovalMeans$Tone.Type == 'B',]
fit.lmer<- lm( Amplitude - Background ~ Colour , data=data)
summary(fit.lmer)

data <- RemovalMeans[RemovalMeans$Tone.Type == 'A',]
fit.lmer<- lm( ampRatio ~  Colour , data=data)
summary(fit.lmer)

data <- RemovalMeans[RemovalMeans$Tone.Type == 'A',]
fit.lmer<- lm( ampSub ~  Colour , data=data)
summary(fit.lmer)

data <- RemovalMeans[RemovalMeans$Tone.Type == 'B',]
fit.lmer<- lm( ampSub ~  Colour , data=data)
summary(fit.lmer)


shapiro.test(data$Amplitude[data$Colour == "yellow"] -data$Background[data$Colour == "yellow"])

shapiro.test(data$Amplitude[data$Colour == "red"] -data$Background[data$Colour == "red"])
hist(data$Amplitude[data$Colour == "yellow"] -data$Background[data$Colour == "yellow"])
hist(data$Amplitude[data$Colour == "red"] -data$Background[data$Colour == "red"])
par(mfrow=c(2, 2))
hist(data$Entropy [data$Colour == "yellow"] )
hist(data$Entropy [data$Colour == "red"] )
hist(data$Entropy [data$Colour == "blue"] )
hist(data$Entropy [data$Colour == "green"] )
shapiro.test(data$Entropy [data$Colour == "yellow"] )
shapiro.test(data$Entropy [data$Colour == "red"] )
shapiro.test(data$Entropy [data$Colour == "blue"] )
shapiro.test(data$Entropy [data$Colour == "green"] )


fit.lmer<- aov(ampRatio ~ Colour, data=RemovalMeans[RemovalMeans$Tone.Type == 'A',])
summary(fit.lmer)
TukeyHSD(fit.lmer)


##Plot Predictions as bar graph
library(ggplot2)
par(mfrow=c(1, 1))
prediction.r <- predict(fit.lmer, type = "response")
prediction.l <- predict(fit.lmer)
predictTrim <- cbind(data, prediction.r, prediction.l )
se <- coef(summary(fit.lmer))[, "Std. Error"]
se.interceptA <- se["(Intercept)"]

trimNone <- predictTrim [predictTrim$Colour == "yellow",]
trimP8 <- predictTrim [predictTrim$Colour == "red",]
trimP9 <- predictTrim [predictTrim$Colour == "blue",]
trimP7 <- predictTrim [predictTrim$Colour == "green",]

#predicted.means <- cbind(trimNone = mean(trimNone$prediction.r), 
#				trimP8 = mean( trimP8$prediction.r),
#				trimP9 = mean( trimP9$prediction.r),
#				trimP7 = mean( trimP7$prediction.r))
meanIntercept <- mean(trimNone$prediction.r)
predicted.means <- cbind(trimNone = mean(trimNone$prediction.r) - meanIntercept , 
				trimP8 = mean(trimP8$prediction.r) - meanIntercept ,
				trimP9 = mean(trimP9$prediction.r) - meanIntercept ,
				trimP7 = mean(trimP7$prediction.r) - meanIntercept )


###Need to convert from binary to proportion
#observed.means <- cbind(trimNone = mean(trimNone$Entropy), 
#			trimP8 = mean(10-trimP8$Entropy),
#			trimP9 = mean(10-trimP9$Entropy),
#			trimP7 = mean(10-trimP7$Entropy))

###Need to convert from binary to proportion
#observed.means <- cbind(trimNone = mean(trimNone$Amplitude - trimNone$Background), 
#				trimP8 = mean(trimP8$Amplitude - trimP8$Background),
#				trimP9 = mean(trimP9$Amplitude - trimP9$Background),
#				trimP7 = mean(trimP7$Amplitude - trimP7$Background))

###Need to convert from binary to proportion
observed.means <- cbind(trimNone = mean(trimNone$AmpSub), 
				trimP8 = mean(trimP8$AmpSub),
				trimP9 = mean(trimP9$AmpSub),
				trimP7 = mean(trimP7$AmpSub))


# Generate predicted means Bars
tempColours <- c('yellow', 'red', 'blue', 'green')
mp <- barplot(predicted.means, stat="identity", beside = T, 
			col = tempColours ,  ylim = c(-10,10) )
#observed means
points(x = mp, y = observed.means)

## Error bars Tonality
mean.pred <- cbind( trimNone = mean(trimNone$prediction.l), 
				trimP8 = mean(trimP8$prediction.l),
				trimP9 = mean(trimP9$prediction.l),
				trimP7 = mean(trimP7$prediction.l))


mean.se.p <- cbind( trimNone = mean(trimNone$prediction.l + se.interceptA ), 
				trimP8 = mean(trimP8$prediction.l + se.interceptA ),
				trimP9 = mean(trimP9$prediction.l + se.interceptA ),
				trimP7 = mean(trimP7$prediction.l + se.interceptA )) 

mean.se.m <- cbind( trimNone = mean(trimNone$prediction.l - se.interceptA ) , 
				trimP8 = mean(trimP8$prediction.l - se.interceptA ) ,
				trimP9 = mean(trimP9$prediction.l - se.interceptA ) ,
				trimP7 = mean(trimP7$prediction.l - se.interceptA ) )


#Standard Error Bars AMPLITUDE
mean.pred <- cbind( trimNone = mean(trimNone$prediction.l) - meanIntercept , 
				trimP8 = mean(trimP8$prediction.l) - meanIntercept ,
				trimP9 = mean(trimP9$prediction.l) - meanIntercept ,
				trimP7 = mean(trimP7$prediction.l) - meanIntercept )


mean.se.p <- cbind( trimNone = mean(trimNone$prediction.l + se.interceptA ) - meanIntercept , 
				trimP8 = mean(trimP8$prediction.l + se.interceptA ) - meanIntercept ,
				trimP9 = mean(trimP9$prediction.l + se.interceptA ) - meanIntercept ,
				trimP7 = mean(trimP7$prediction.l + se.interceptA ) - meanIntercept ) 

mean.se.m <- cbind( trimNone = mean(trimNone$prediction.l - se.interceptA ) - meanIntercept , 
				trimP8 = mean(trimP8$prediction.l - se.interceptA ) - meanIntercept ,
				trimP9 = mean(trimP9$prediction.l - se.interceptA ) - meanIntercept ,
				trimP7 = mean(trimP7$prediction.l - se.interceptA ) - meanIntercept )

# Plot the vertical lines of the error bars
segments(mp,mean.se.p, mp, mean.se.m, lwd=2)
segments(mp - 0.1, mean.se.p, mp + 0.1, mean.se.p, lwd=2) # 1. The lower bar
segments(mp - 0.1, mean.se.m, mp + 0.1, mean.se.m, lwd=2) # 2. The upper bar





tempGlm <- lmer( Entropy ~ Colour + (1|ID), data=RemovalMeans[RemovalMeans$Tone == "B",])
summary(tempGlm )
tempGlm <- lmer( Amplitude ~ Colour+ (1|ID), data=RemovalMeans[RemovalMeans$Tone == "B",])
summary(tempGlm )
tempGlm <- lmer( Entropy ~ Colour + (1|ID), data=RemovalMeans[RemovalMeans$Tone == "A",])
summary(tempGlm )
tempGlm <- lmer( Amplitude ~ Colour+ (1|ID), data=RemovalMeans[RemovalMeans$Tone == "A",])
summary(tempGlm )
### All Data ###

tempGlm <- glm( Entropy ~ Colour + (1|ID), family=gaussian, data=RemovalMeans[RemovalMeans$Tone == "B",])
tempGlm <- glm( Entropy ~ Colour, family=gaussian, data=RemovalMeans[RemovalMeans$Tone == "A",])

tempGlm <- glm( Amplitude ~ Colour, family=gaussian, data=RemovalMeans[RemovalMeans$Tone == "B",])
tempGlm <- glm( Amplitude ~ Colour, family=gaussian, data=RemovalMeans[RemovalMeans$Tone == "A",])

tempGlm <- glm( Amplitude ~ Colour + (1+ID/Colour), family=gaussian, data=RemovalMeans[RemovalMeans$Tone == "B",])

TempData <- rbind(RemovalAnalysisDF[RemovalAnalysisDF$Colour == "red",], RemovalAnalysisDF[RemovalAnalysisDF$Colour == "yellow",])

tempGlm <- glm( Entropy ~ Colour + (1+ToneID/Colour), family=gaussian, data=TempData )
tempGlm <- glm( Entropy ~ Colour + (1+ToneID/Colour), family=gaussian, data=RemovalAnalysisDF[RemovalAnalysisDF$Tone == "A",])

tempGlm <- glm( Amplitude ~ Colour + (1+ToneID/Colour), family=gaussian, data=RemovalFilteredDF [RemovalFilteredDF$Tone == "B",])
tempGlm <- glm( Amplitude ~ Colour + (1+ToneID/Colour), family=gaussian, data=RemovalFilteredDF [RemovalFilteredDF$Tone == "A",])
n <- 0
rep(n <- n+2, 63)
TempDataA$Amplitude[2,4,]
TempDataC <- 10*log10(10^TempDataA$Amplitude - 10^TempDataB$Amplitude)
summary(tempGlm )

nrow(RemovalFilteredDF[duplicated(RemovalFilteredDF$WhistleID) == FALSE,])
s

'Trim P9' <- 'blue')
'Trim P8' <- 'red')
'Trim P7' <- 'green')
'Control''yellow')
else <- 'black')
